(load "support/genhtml.scm")
(load "support/athena-defs.scm")

(define page-contents
  ($SEQUENTIALLY
   (H1 (TEXT "Matteo Frigo's Home Page"))
   (section "Software")

   (UL
    
    (LI 
     (TEXT (simple-link cilk-web-page "Cilk")
	   " is a multithreaded parallel language with a provably good "
	   "scheduler."))

    (LI 
     (TEXT (simple-link fftw-web-page "FFTW")
	   " (Fastest Fourier Transform in the West) is a library that "
	   "computes Fourier transforms in a nonstandard manner."))

    (LI (TEXT (simple-link gmeteor-web-page "gmeteor")
	      " is a flexible program for FIR filter design."))

    )

   (section "Papers")
   (TEXT "See " (simple-link "papers.html" "this web page") ".")

   (section "Quick hacks")
   (UL
    (LI (TEXT (simple-link "hacks/source.tar"
			   "Source code for this web page")
	      " (in Scheme)."))

    (LI (TEXT (simple-link "hacks/pipe.scm"
			   "Functional pipelines in Scheme")
	     ". (I learned the trick from Olin Shivers.) "
	     "See also the "
	     (simple-link "hacks/pipe.ml" "OCaml version")
	     "."))

    (LI 
     (TEXT (simple-link "hacks/schinken.tar"
			"Schinken")
	   " is a personal-finance system written in Scheme.  "
	   "Basic idea: the evaluation of"
	   (P
	    (CODE
	     (TEXT
	      "((may 1 2002) (USD 100.00) \"payment\" checking credit-card)")))
	   " does the right thing."))

    (LI
     (TEXT "Unpublished memo: "
	   (simple-link "hacks/density-product-real-gaussians.dvi"
    "Density of the product of two real Gaussian random variables")
	   ".  This result is mentioned in the paper "
	   (EM (TEXT "On the Frequency Function of $xy$,"))
	   " by Cecil C. Craig, Ann. Math. Statist. Volume 7, "
	   "Number 1 (1936), 1-15, where it is said to be ``well-known''"
	   " and attributed to a 1932 paper by J. Wishart and M. S. Bartlett."))

    (LI
     (TEXT "Unpublished memo: "
	   (simple-link "hacks/density-product-complex-gaussians.dvi"
    "Density of the product of two complex Gaussian random variables")
	   ".  This result must be known, but I am not aware of any reference."))

    (LI
     (TEXT "Unpublished memo: "
	   (simple-link "hacks/ternary.dvi"
			"Radix-3 computation of twiddle factors")
	   "."))


    (LI
     (TEXT (simple-link "hacks/nvsetvol.c" "nvsetvol.c")
	   " is a simple program that sets the volume of the Power Macintosh "
	   "startup chime from linux.  Setting the volume to 0 disables "
	   "the startup sound altogether."))
    )
    
   (section "Public key")
   (TEXT (simple-link "pubkey.asc" "Here ") " is my GPG public key.")

   ))

(define page 
  (athena-page "Matteo Frigo's Home Page" "./" page-contents))

(print-html page)