(require 'posix-time)

(define supertech-web-page "http://supertech.lcs.mit.edu/")
(define cilk-web-page (string-append supertech-web-page "cilk/"))
(define fftw-web-page "http://fftw.org/")
(define gmeteor-web-page "http://gmeteor.sourceforge.net/")

(define (on-theory filename)
  (string-append "ftp://theory.lcs.mit.edu/pub/cilk/" filename))
(define (on-fftw filename)
  (string-append "ftp://ftp.fftw.org/pub/fftw/" filename))
(define (on-paperdir filename)
  (string-append "http://www.fftw.org/~athena/papers/" filename))

(define (simple-link link name) 
  (A:HREF link (TEXT name)))
	    
(define cilk-maintainer
  (simple-link "mailto:athena@fftw.org" "Matteo Frigo"))

(define (athena-head titl topdir)
  (define (href name)
    (list 'HREF (string-append topdir name)))
  (HEAD
   ($SEQUENTIALLY
    (A:NAME "top-of-logo" (TEXT ""))
    (META '(http-equiv "name") '(content "Matteo Frigo Home Page"))
    (META '(http-equiv "distribution") '(content "global"))
    (META '(name "alias")
	  '(content "http://theory.lcs.mit.edu/~athena/"))
    (TITLE ($VERBATIM titl))
    (LINK '(rel "BOOKMARK") (list 'title titl) (href "index.html"))
    (LINK '(rel "Contents") (href "index.html"))
    (LINK '(rel "STYLESHEET") (href "cilk.css") '(type "text/css")))))

(define horizontal-rule
  (P (HR '(noshade)
	 '(width "90%")
	 '(size "1"))
     '(align "center")))

(define (athena-tail topdir)
  ($SEQUENTIALLY
   horizontal-rule
   (TEXT "This page maintained by: " 
	 cilk-maintainer
	 ". Last updated: "
	 (asctime (localtime (current-time)))
	 )))

(define (athena-body titl topdir contents)
  (BODY
   ($SEQUENTIALLY contents
		  (athena-tail topdir))
   '(text "#000000")
   '(bgcolor "#FFFFFF")))
   
(define (athena-page titl topdir contents)
  ($SEQUENTIALLY
   (DOCTYPE)
   ($NEWLINE)
   (comment "This file was automatically generated. DO NOT EDIT!") 
   ($NEWLINE)
   (HTML 
    ($SEQUENTIALLY
     (athena-head titl topdir)
     (athena-body titl topdir contents)
     ))))
	      
(define (section name)
  ($SEQUENTIALLY
   (H2 (TEXT name))))

(define Matteo-Frigo 
  (simple-link "http://www.fftw.org/~athena" "Matteo Frigo"))

(define Harald-Prokop 
  (simple-link "http://supertech.lcs.mit.edu/~prokop" "Harald Prokop"))

(define Keith-Randall 
  (simple-link "http://theory.lcs.mit.edu/~randall" "Keith H. Randall"))

(define cel
  (simple-link "http://supertech.lcs.mit.edu/~cel" "Charles E. Leiserson"))

(define Sridhar-Ramachandran "Sridhar Ramachandran")

(define Andy-Stark 
  (simple-link "http://www-swiss.ai.mit.edu/~astark" "Andrew F. Stark"))

(define Steven-Johnson 
  (A:HREF "http://math.mit.edu/~stevenj/"
	  (TEXT "Steven G. Johnson")))

(define Feng-Mingdong
  (simple-link "http://theory.lcs.mit.edu/~fengmd" "Mingdong Feng"))

(define Bin-Song
  (simple-link "http://theory.lcs.mit.edu/~bsong" "Bin Song"))

(define Volker-Strumpen
  (simple-link "http://strumpen.net/" "Volker Strumpen"))

(define Balkrishna-Ramkumar
  (simple-link "http://www.eng.uiowa.edu/~ramkumar"
	       "Balkrishna Ramkumar"))

(define Phil-Lisiecki
  (simple-link "http://web.mit.edu/lisiecki/www/home.html"
	       "Philip A. Lisiecki"))

(define Bobby-Blumofe "Robert D. Blumofe")

(define Chris-Joerg "Christopher F. Joerg")

(define Bradley-Kuszmaul
  (simple-link "http://arch.cs.yale.edu:8080/~bradley/"
	       "Bradley C. Kuszmaul"))

(define Yuli-Zhou "Yuli Zhou")

(define Don-Dailey "Don Dailey")

(define Howard-Lu "Howard J. Lu")

(define Robert-Miller "Robert C. Miller")

(define David-Park "David S. Park")

(define Michael-Halbherr "Michael Halbherr")

(define Eric-Brewer
  (simple-link "http://jukebox.lcs.mit.edu:80/~brewer/"
               "Eric A. Brewer"))
(define Supercomputing-Group
  "Supercomputing Technologies Group")
(define Igor-Lyubashevskiy
  "Igor B. Lyubashevskiy")
(define Nathaniel-Kushman
  "Nathaniel A. Kushman")
(define Guang-Ien-Cheng
  "Guang-Ien Cheng")

(define Yaron-Shoham
  (simple-link "http://www.math.tau.ac.il/~ysh/"
	       "Yaron Shoham"))

(define Cilkchess (simple-link "/chess" "Cilkchess"))
(define *Socrates (simple-link "/chess" "*Socrates"))

(define LCS
  (simple-link "http://www.lcs.mit.edu/"
	       "Laboratory for Computer Science"))

(define Bruce-Maggs
  (simple-link "http://www.cs.cmu.edu/~bmm/"
	       "Bruce M. Maggs"))

(define Aske-Plaat
  (simple-link "http://www.cs.vu.nl/~aske/"
	       "Aske Plaat"))

(define Ibrahim-Abou-Faycal "Ibrahim Abou-Faycal")
(define Jon-Feldman 
  (simple-link "http://www.columbia.edu/~jf2189/index.html" "Jon Feldman"))

(define Aydin-Buluc
  (simple-link "http://gauss.cs.ucsb.edu/~aydin/" "Aydin Buluc"))

(define Jeremy-Fineman
  (simple-link "http://people.csail.mit.edu/jfineman/" "Jeremy T. Fineman"))

(define John-Gilbert
  (simple-link "http://www.cs.ucsb.edu/~gilbert/" "John R. Gilbert"))

(define (create-abstract text)
  text)


